
# example python plugin-model
# count carbons in smiles 

from implugin import IMPlugin

from modeldescriptions import ContModelDescription

class CarbonCount(IMPlugin):
  def __init__(self):
    model = ContModelDescription('MOD_C_COUNT', 
                                  0.0,
                                  10000.0,
                                  header='Carbon Count',
                                  interactive = True,
                                  shortName = 'Carbon counter',
                                  longName = 'Carbon counter',
                                  description = 'Count the carbons in the molecule')
    IMPlugin.__init__(self, model)
                                            
  def predict(self, smiles, extra):
    smiles = smiles.replace("Cl","")
    return [ float(smiles.count('C')+smiles.count('c')), 0.0 ]

class Plugin(CarbonCount): # the hook
   pass
