
# example python plugin-model
# performs salt splitting

from modeldescriptions import CatModelDescription

from implugin import IMPlugin

class CatToxic(IMPlugin):
  def __init__(self):
    model = CatModelDescription('MOD_CAT_TOXIC',
                                ['Fine','Mild','Deadly'],
                                  header='CatToxic',
                                  interactive=True,
                                  glowingCapable=True,
                                  glowingInteractive=True,
                                  shortName='CatToxic',
                                  longName='Categorized Toxicity',
                                  description='Returns Fine if no As or C#N present, Mild if one is present, Deadly if both present.  GM data is completly fake.')
    IMPlugin.__init__(self, model)
        
  def predict(self, smiles, gmReq=False):
    asCount = smiles.count('As')
    cnCount = smiles.count('C#N')
    if asCount > 0 and cnCount > 0:
      prediction = [0.0,0.0,1.0]
    elif asCount > 0 or cnCount > 0:
      prediction = [0.0,1.0,0.0]
    else:
      prediction = [1.0,0.0,0.0]
    
    if gmReq == True:
      return (prediction, '')
    else:
      return prediction
  
class Plugin(CatToxic): # the hook
   pass
