
# example python plugin-model
# takes one external descriptor

import popen2

from implugin import IMPlugin

from modeldescriptions import ContModelDescription

class ExtDesc1(IMPlugin):
  def __init__(self):
    model = ContModelDescription('ExtDesc1', 
                                  0.0,
                                  10000.0,
                                  externalDescriptorsRequired = 1,
                                  externalDescriptorNames = ["ed1"],
                                  header='ExtDesc1',
                                  interactive = True,
                                  shortName = 'One ext desc.',
                                  longName = 'One external descriptor',
                                  description = 'Asks for an external descriptor called "ed1".')
    IMPlugin.__init__(self, model)

  def predict(self, smiles, extra):
    if type(extra) != type("") or extra == "":
      raise Exception("missing descriptors")
    eds = extra.split(",")
    return [ float(eds[0]) + 1.0, 0.0 ]

class Plugin(ExtDesc1): # the hook
   pass
