
# example python plugin-model
# takes two external descriptors

import popen2

from implugin import IMPlugin

from modeldescriptions import ContModelDescription

class ExtDesc2(IMPlugin):
  def __init__(self):
    model = ContModelDescription('ExtDesc2', 
                                  0.0,
                                  10000.0,
                                  externalDescriptorsRequired = 2,
                                  externalDescriptorNames = ["ed1", "ed2"],
                                  header='ExtDesc2',
                                  interactive = True,
                                  shortName = '2 ext descs.',
                                  longName = 'Two external descriptors',
                                  description = 'Asks for external descriptors called "ed1" and "ed2".')
    IMPlugin.__init__(self, model)

  def predict(self, smiles, extra):
    if type(extra) != type("") or extra == "":
      raise Exception("missing descriptors")
    eds = extra.split(",")
    if len(eds) != 2:
      raise Exception("expecting two descriptors")
    return [ float(eds[0]) + float(eds[1]), 0.0 ]

class Plugin(ExtDesc2): # the hook
   pass
