
# example python plugin-model
# demonstrates calling out to a shell command

import os, popen2

from implugin import IMPlugin

from modeldescriptions import ContModelDescription

class Random(IMPlugin):
  def __init__(self):
    model = ContModelDescription('RANDOM', 
                                  0.0,
                                  10000.0,
                                  header='Random Number',
                                  interactive = True,
                                  shortName = 'PRNG',
                                  longName = 'Pseudorandom Number Generator',
                                  description = 'generate a pseudo random number')
    IMPlugin.__init__(self, model)
                                            
  def random(self):
    if os.path.exists('./models/randomcmd.py'):
     pyf = './models/randomcmd.py'
    else:
     pyf = '../../models/randomcmd.py'
    cmd = popen2.popen2('/usr/local/bin/python ' + pyf)
    v = float(cmd[0].read())
    try:
      cmd[0].close()
      cmd[1].close()
    except:
      pass
    return v 
    
  def predict(self, smiles, extra):
    return [ self.random(), 0.0 ]

class Plugin(Random): # the hook
   pass
