
# example python plugin-model
# performs salt splitting

import string
from modeldescriptions import MoleculeModelDescription

from implugin import IMPlugin

class SaltSplitter(IMPlugin):
  def __init__(self):
    model = MoleculeModelDescription('MOD_SALT_SPLIT', 
                                     interactive = True,
                                     shortName = 'Salt splitter',
                                     longName = 'Split salt splitter',
                                     header='Salt splitter',
                                     description = 'Removes smaller component of a dot separated smiles compound')
    IMPlugin.__init__(self, model) 
    
  def predict(self, smiles, extra):
    list = string.split(smiles,'.')
    smallest = list[0]
    smallestlen = len(smallest)
    for i in list[1:]:
      if len(i) < smallestlen:
        smallestlen = len(i)
        smallest = i
    return smallest
    

class Plugin(SaltSplitter): # the hook
  pass

