
# example python plugin-model
# performs salt splitting

from modeldescriptions import ContModelDescription

from implugin import IMPlugin

class ExtStrLen(IMPlugin):
  def __init__(self):
    model = ContModelDescription('MOD_EXT_STRING_LEN', 
                                 0.0,
                                 10000.0,
                                 externalDescriptorsRequired=0,
                                 #externalDescriptorNames=['arbitraryDescriptor1,arbitraryDescriptor2'],
                                 externalDescriptorNames=[],
                                 header='String length (smiles)',
                                 interactive = True,
                                 shortName = 'StringLength',
                                 longName = 'String and External Descriptors length',
                                 description = 'Returns the length of the smiles string and the length of the external descritpors string')
                                            
    IMPlugin.__init__(self, model) 
    
  def predict(self, smiles, extra):
    if type(extra) == type(""):
       prediction = [ float(len(smiles)+len(extra)), 0.0 ]
    else:
       prediction = [ float(len(smiles)), 0.0 ]
    return prediction


class Plugin(ExtStrLen): # the hook
  pass

