
def ws(s):
  return s.lstrip(" \t\n\r")

def breakon(s, ch):
  if len(s) == 0:
    return ("", "")
  if s[0] == ch:
    s = s[1:]
  i = 0
  while True:
    if i == len(s):
      break
    if s[i] == ch:
      if i == 0 or s[i-1] != '\\':
        break
    i += 1
  return (s[:i], s[i+1:])
  
def breakoff(s):
  if len(s) == 0:
    return ("", "")
  i = 0
  while True:
    if i == len(s):
      break
    if s[i] in ", \t\n\r":
        break
    i += 1
  return (s[:i], s[i+1:])


def stringtolist(s):
  '''parse a string to a python list'''
  l = []
  s = ws(s)
  if s[0] != '[': 
    return []
  s = s[1:]

  while len(s) > 0:
    s = ws(s)
    if s[0] == "[":
      (ll, rest) = stringtolist(s)
      l.append(ll) 
      s = rest
    if s[0] == ",":
      s = s[1:]
      continue
    if s[0] == '\'': 
      (str, rest) = breakon(s, '\'')
      l.append(str)
      s = rest
    elif s[0] == '"':
      (str, rest) = breakon(s, '"')
      l.append(str)
      s = rest
    elif s[0] == ']':
      s = s[1:]
      break
    else:
      (str, rest) = breakoff(s)
      l.append(str)
      s = rest
    
  return (l, s)
  
